/*
 * Copyright (c) 2011 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _MORSTRUCT_H
#define _MORSTRUCT_H

typedef struct MOR_INIT_PARAMS {
	GEN_STRING128 canDev;
	GEN_STRING128 relayBoardDev;
	int initBase;
	int initSpine;
} MOR_INIT_PARAMS;

typedef enum MOR_MODE {
	MOR_UNINITIALIZED = 0,
	MOR_MOTORS_OFF,
	MOR_READY,
	MOR_MANUAL,
	MOR_TRACK,
	MOR_EMERGENCY
} MOR_MODE;

/* Track parameters */
typedef struct MOR_TRACK_PARAMS {
	GENPOS_POSTER_NAME posterName;
	GENPOS_TRACK_MODE mode;
} MOR_TRACK_PARAMS;

/* Spine */
typedef struct MOR_SPINE_REF {
	double pos;
	double speed;
} MOR_SPINE_REF;

#define MOR_SPINE_STOP_HIGH 0x01
#define MOR_SPINE_STOP_LOW  0x02

typedef struct MOR_SPINE_STATE {
	double pos;
	double speed;
	unsigned int stopSwitches;
	int unused;
} MOR_SPINE_STATE;

typedef struct MOR_WHEEL_DATA {
	double steerVel;
	double steerPos;
	double driveVel;
	double drivePos;
	double steerCurrent;
	double driveCurrent;
	int steerMotorState;
	int driveMotorState;
} MOR_WHEEL_DATA;

typedef struct MOR_ROBOT_DATA {
	/* relayboard state */
	unsigned int relayState;
	int charge_c;
	int voltage;
	int temperature;
	MOR_WHEEL_DATA wheels[4];
} MOR_ROBOT_DATA;

	
#endif
