
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef mor_ERROR_H
#define mor_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_mor    (11080)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_mor_BASE_NOT_INITIALIZED H2_ENCODE_ERR(M_mor       , 1)
#define S_mor_BAD_CMD_PARAMETERS   H2_ENCODE_ERR(M_mor       , 2)
#define S_mor_BxASE_NOT_INITIALIZED H2_ENCODE_ERR(M_mor       , 3)
#define S_mor_BAD_REF_DATA         H2_ENCODE_ERR(M_mor       , 4)
#define S_mor_TRACKING_ON          H2_ENCODE_ERR(M_mor       , 5)
#define S_mor_BAR_REF              H2_ENCODE_ERR(M_mor       , 6)
#define S_mor_SPINE_NOT_INITIALIZED H2_ENCODE_ERR(M_mor       , 7)
#define S_mor_CMD_STOP_TRACK       H2_ENCODE_ERR(M_mor       , 8)
#define S_mor_POSTER_NOT_FOUND     H2_ENCODE_ERR(M_mor       , 9)
#define S_mor_JOYSTICK_ERROR       H2_ENCODE_ERR(M_mor       , 10)
#define S_mor_MOR_LIB_ERROR        H2_ENCODE_ERR(M_mor       , 11)
#define S_mor_BAD_REF              H2_ENCODE_ERR(M_mor       , 12)
#define S_mor_MOTORS_OFF           H2_ENCODE_ERR(M_mor       , 13)
#define S_mor_MORLIB_ERROR         H2_ENCODE_ERR(M_mor       , 14)
#define S_mor_EMERGENCY_STOP       H2_ENCODE_ERR(M_mor       , 15)


/* std errors */
#define S_mor_stdGenoM_ACTIVITY_INTERRUPTED       726197249   /* 11080<<16 | 0x8000 | 100<<8 | 1 */
#define S_mor_stdGenoM_TOO_MANY_ACTIVITIES        726197250   /* 11080<<16 | 0x8000 | 100<<8 | 2 */
#define S_mor_stdGenoM_ACTIVITY_FAILED            726197251   /* 11080<<16 | 0x8000 | 100<<8 | 3 */
#define S_mor_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 726197252   /* 11080<<16 | 0x8000 | 100<<8 | 4 */
#define S_mor_stdGenoM_UNKNOWN_ACTIVITY           726197253   /* 11080<<16 | 0x8000 | 100<<8 | 5 */
#define S_mor_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 726197254   /* 11080<<16 | 0x8000 | 100<<8 | 6 */
#define S_mor_stdGenoM_SYSTEM_ERROR               726197255   /* 11080<<16 | 0x8000 | 100<<8 | 7 */
#define S_mor_stdGenoM_ACTIVITY_ALREADY_ENDED     726197256   /* 11080<<16 | 0x8000 | 100<<8 | 8 */
#define S_mor_stdGenoM_WAIT_INIT_RQST             726197257   /* 11080<<16 | 0x8000 | 100<<8 | 9 */
#define S_mor_stdGenoM_CONTROL_CODEL_ERROR        726197258   /* 11080<<16 | 0x8000 | 100<<8 | 10 */
#define S_mor_stdGenoM_EXEC_TASK_SUSPENDED        726197259   /* 11080<<16 | 0x8000 | 100<<8 | 11 */
#define S_mor_stdGenoM_BAD_BLOCK_TYPE             726197260   /* 11080<<16 | 0x8000 | 100<<8 | 12 */
#define S_mor_stdGenoM_BAD_POSTER_TYPE            726197261   /* 11080<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define MOR_H2_ERR_MSGS {\
    {"BASE_NOT_INITIALIZED", 1}, \
    {"BAD_CMD_PARAMETERS", 2}, \
    {"BxASE_NOT_INITIALIZED", 3}, \
    {"BAD_REF_DATA", 4}, \
    {"TRACKING_ON", 5}, \
    {"BAR_REF", 6},\
    {"SPINE_NOT_INITIALIZED", 7},\
    {"CMD_STOP_TRACK", 8},\
    {"POSTER_NOT_FOUND", 9},\
    {"JOYSTICK_ERROR", 10},\
    {"MOR_LIB_ERROR", 11},\
    {"BAD_REF", 12},\
    {"MOTORS_OFF", 13},\
    {"MORLIB_ERROR", 14},\
    {"EMERGENCY_STOP", 15},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int morRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
