
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef mor_POSTER_LIB_H
#define mor_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "morType.h"
#include "morError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[MOR_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} MOR_CNTRL_STR;

/* For consistency with other posters */
typedef MOR_CNTRL_STR MOR_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "morPosterLibStruct.h"



/* Posters */
#define MOR_CNTRL_POSTER_NAME genomInstanceSuffixName("mor", "Cntrl")
#define MOR_MEPOS_POSTER_NAME genomInstanceSuffixName("mor", "MEPos")
#define MOR_ODO_POSTER_NAME genomInstanceSuffixName("mor", "Odo")
#define MOR_REF_POSTER_NAME genomInstanceSuffixName("mor", "Ref")
#define MOR_SPINE_POSTER_NAME genomInstanceSuffixName("mor", "Spine")
#define MOR_RAWDATA_POSTER_NAME genomInstanceSuffixName("mor", "RawData")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS morPosterInit ( void );
extern POSTER_ID morCntrlPosterID ();
extern STATUS morCntrlPosterRead ( MOR_CNTRL_STR *morCntrlStrId );
extern STATUS morCntrlPosterInit ( void );
extern STATUS morCntrlInstancePosterRead(const char *name, MOR_CNTRL_STR *morCntrlStrId);
extern STATUS morMEPosPosterInit ( void );
extern POSTER_ID morMEPosPosterID ( void );
extern STATUS morMEPosPosterRead ( MOR_MEPOS_POSTER_STR *x );
extern STATUS morMEPosInstancePosterRead ( const char *, MOR_MEPOS_POSTER_STR * );
extern STATUS morMEPosmePosPosterRead ( POM_ME_POS *mePos );
extern STATUS morMEPosmePosInstancePosterRead( const char *, POM_ME_POS * );
extern STATUS morOdoPosterInit ( void );
extern POSTER_ID morOdoPosterID ( void );
extern STATUS morOdoPosterRead ( MOR_ODO_POSTER_STR *x );
extern STATUS morOdoInstancePosterRead ( const char *, MOR_ODO_POSTER_STR * );
extern STATUS morOdoRobotPosterRead ( GENPOS_CART_STATE *Robot );
extern STATUS morOdoRobotInstancePosterRead( const char *, GENPOS_CART_STATE * );
extern STATUS morRefPosterInit ( void );
extern POSTER_ID morRefPosterID ( void );
extern STATUS morRefPosterRead ( MOR_REF_POSTER_STR *x );
extern STATUS morRefInstancePosterRead ( const char *, MOR_REF_POSTER_STR * );
extern STATUS morRefRefPosterRead ( GENPOS_CART_REF *Ref );
extern STATUS morRefRefInstancePosterRead( const char *, GENPOS_CART_REF * );
extern STATUS morSpinePosterInit ( void );
extern POSTER_ID morSpinePosterID ( void );
extern STATUS morSpinePosterRead ( MOR_SPINE_POSTER_STR *x );
extern STATUS morSpineInstancePosterRead ( const char *, MOR_SPINE_POSTER_STR * );
extern STATUS morSpineStatePosterRead ( MOR_SPINE_STATE *State );
extern STATUS morSpineStateInstancePosterRead( const char *, MOR_SPINE_STATE * );
extern STATUS morSpineRefPosterRead ( MOR_SPINE_REF *Ref );
extern STATUS morSpineRefInstancePosterRead( const char *, MOR_SPINE_REF * );
extern STATUS morRawDataPosterInit ( void );
extern POSTER_ID morRawDataPosterID ( void );
extern STATUS morRawDataPosterRead ( MOR_RAWDATA_POSTER_STR *x );
extern STATUS morRawDataInstancePosterRead ( const char *, MOR_RAWDATA_POSTER_STR * );
extern STATUS morRawDataDataPosterRead ( MOR_ROBOT_DATA *Data );
extern STATUS morRawDataDataInstancePosterRead( const char *, MOR_ROBOT_DATA * );
#ifdef __cplusplus
}
#endif
#endif

