
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MOR_PRINT_H
#define MOR_PRINT_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/genBasicPrint.h"

#include "server/genPosPrint.h"

#include "server/pomPrint.h"


#include "morPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern void print_struct_MOR_RAWDATA_POSTER_STR ( FILE *out,
     struct MOR_RAWDATA_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_SPINE_POSTER_STR ( FILE *out,
     struct MOR_SPINE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_REF_POSTER_STR ( FILE *out,
     struct MOR_REF_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_ODO_POSTER_STR ( FILE *out,
     struct MOR_ODO_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_MEPOS_POSTER_STR ( FILE *out,
     struct MOR_MEPOS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_GENOM_STR ( FILE *out,
     struct MOR_GENOM_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_ROBOT_DATA ( FILE *out,
     struct MOR_ROBOT_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_WHEEL_DATA ( FILE *out,
     struct MOR_WHEEL_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_SPINE_STATE ( FILE *out,
     struct MOR_SPINE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_SPINE_REF ( FILE *out,
     struct MOR_SPINE_REF *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_TRACK_PARAMS ( FILE *out,
     struct MOR_TRACK_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_MOR_MODE ( FILE *out,
     enum MOR_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_MOR_INIT_PARAMS ( FILE *out,
     struct MOR_INIT_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void print_MOR_INIT_PARAMS ( FILE *out,
     MOR_INIT_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_MODE ( FILE *out,
     MOR_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_TRACK_PARAMS ( FILE *out,
     MOR_TRACK_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_SPINE_REF ( FILE *out,
     MOR_SPINE_REF *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_SPINE_STATE ( FILE *out,
     MOR_SPINE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_WHEEL_DATA ( FILE *out,
     MOR_WHEEL_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_ROBOT_DATA ( FILE *out,
     MOR_ROBOT_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_GENOM_STR ( FILE *out,
     MOR_GENOM_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_MEPOS_POSTER_STR ( FILE *out,
     MOR_MEPOS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_ODO_POSTER_STR ( FILE *out,
     MOR_ODO_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_REF_POSTER_STR ( FILE *out,
     MOR_REF_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_SPINE_POSTER_STR ( FILE *out,
     MOR_SPINE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_MOR_RAWDATA_POSTER_STR ( FILE *out,
     MOR_RAWDATA_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
#ifdef __cplusplus
}
#endif

#endif /* MOR_PRINT_H */

