
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MOR_PRINTXML_H
#define MOR_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/genBasicPrintXML.h"

#include "server/genPosPrintXML.h"

#include "server/pomPrintXML.h"


#include "morPosterLib.h"

/* Prototypes */
extern void printXML_struct_MOR_RAWDATA_POSTER_STR ( FILE *out, char *name,
     struct MOR_RAWDATA_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_SPINE_POSTER_STR ( FILE *out, char *name,
     struct MOR_SPINE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_REF_POSTER_STR ( FILE *out, char *name,
     struct MOR_REF_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_ODO_POSTER_STR ( FILE *out, char *name,
     struct MOR_ODO_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_MEPOS_POSTER_STR ( FILE *out, char *name,
     struct MOR_MEPOS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_GENOM_STR ( FILE *out, char *name,
     struct MOR_GENOM_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_ROBOT_DATA ( FILE *out, char *name,
     struct MOR_ROBOT_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_WHEEL_DATA ( FILE *out, char *name,
     struct MOR_WHEEL_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_SPINE_STATE ( FILE *out, char *name,
     struct MOR_SPINE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_SPINE_REF ( FILE *out, char *name,
     struct MOR_SPINE_REF *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_TRACK_PARAMS ( FILE *out, char *name,
     struct MOR_TRACK_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_MOR_MODE ( FILE *out, char *name,
     enum MOR_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MOR_INIT_PARAMS ( FILE *out, char *name,
     struct MOR_INIT_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_MOR_INIT_PARAMS ( FILE *out, char *name,
     MOR_INIT_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_MODE ( FILE *out, char *name,
     MOR_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_TRACK_PARAMS ( FILE *out, char *name,
     MOR_TRACK_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_SPINE_REF ( FILE *out, char *name,
     MOR_SPINE_REF *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_SPINE_STATE ( FILE *out, char *name,
     MOR_SPINE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_WHEEL_DATA ( FILE *out, char *name,
     MOR_WHEEL_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_ROBOT_DATA ( FILE *out, char *name,
     MOR_ROBOT_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_GENOM_STR ( FILE *out, char *name,
     MOR_GENOM_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_MEPOS_POSTER_STR ( FILE *out, char *name,
     MOR_MEPOS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_ODO_POSTER_STR ( FILE *out, char *name,
     MOR_ODO_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_REF_POSTER_STR ( FILE *out, char *name,
     MOR_REF_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_SPINE_POSTER_STR ( FILE *out, char *name,
     MOR_SPINE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOR_RAWDATA_POSTER_STR ( FILE *out, char *name,
     MOR_RAWDATA_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* MOR_PRINT_XML_H */

