
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef mor_TCLSERV_CLIENT_ERROR_H
#define mor_TCLSERV_CLIENT_ERROR_H

#include <server/morError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum mor_error {
	E_mor_OK					  			= 0,

	/* module errors */
	E_mor_BASE_NOT_INITIALIZED           = S_mor_BASE_NOT_INITIALIZED,
	E_mor_BAD_CMD_PARAMETERS             = S_mor_BAD_CMD_PARAMETERS,
	E_mor_BxASE_NOT_INITIALIZED          = S_mor_BxASE_NOT_INITIALIZED,
	E_mor_BAD_REF_DATA                   = S_mor_BAD_REF_DATA,
	E_mor_TRACKING_ON                    = S_mor_TRACKING_ON,
	E_mor_BAR_REF                        = S_mor_BAR_REF,
	E_mor_SPINE_NOT_INITIALIZED          = S_mor_SPINE_NOT_INITIALIZED,
	E_mor_CMD_STOP_TRACK                 = S_mor_CMD_STOP_TRACK,
	E_mor_POSTER_NOT_FOUND               = S_mor_POSTER_NOT_FOUND,
	E_mor_JOYSTICK_ERROR                 = S_mor_JOYSTICK_ERROR,
	E_mor_MOR_LIB_ERROR                  = S_mor_MOR_LIB_ERROR,
	E_mor_BAD_REF                        = S_mor_BAD_REF,
	E_mor_MOTORS_OFF                     = S_mor_MOTORS_OFF,
	E_mor_MORLIB_ERROR                   = S_mor_MORLIB_ERROR,
	E_mor_EMERGENCY_STOP                 = S_mor_EMERGENCY_STOP,


	/* std errors */
	E_mor_ACTIVITY_INTERRUPTED           = S_mor_stdGenoM_ACTIVITY_INTERRUPTED,
	E_mor_TOO_MANY_ACTIVITIES            = S_mor_stdGenoM_TOO_MANY_ACTIVITIES,
	E_mor_ACTIVITY_FAILED                = S_mor_stdGenoM_ACTIVITY_FAILED,
	E_mor_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_mor_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_mor_UNKNOWN_ACTIVITY               = S_mor_stdGenoM_UNKNOWN_ACTIVITY,
	E_mor_FORBIDDEN_ACTIVITY_TRANSITION  = S_mor_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_mor_SYSTEM_ERROR                   = S_mor_stdGenoM_SYSTEM_ERROR,
	E_mor_ACTIVITY_ALREADY_ENDED         = S_mor_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_mor_WAIT_INIT_RQST                 = S_mor_stdGenoM_WAIT_INIT_RQST,
	E_mor_CONTROL_CODEL_ERROR            = S_mor_stdGenoM_CONTROL_CODEL_ERROR,
	E_mor_EXEC_TASK_SUSPENDED            = S_mor_stdGenoM_EXEC_TASK_SUSPENDED,
	E_mor_BAD_BLOCK_TYPE                 = S_mor_stdGenoM_BAD_BLOCK_TYPE,
	E_mor_BAD_POSTER_TYPE                = S_mor_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum mor_error mor_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int mor_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the mor context.
 *
 * Returns NULL in case of failure
 */
const char* mor_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
