
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MOR_SCAN_H
#define MOR_SCAN_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/genBasicTclservClientDecode.h"

#include "server/tclservClient/genPosTclservClientDecode.h"

#include "server/tclservClient/pomTclservClientDecode.h"


/* Structures du module */
#include "server/morPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
int scan_buf_struct_MOR_RAWDATA_POSTER_STR (char** buf, struct MOR_RAWDATA_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_MOR_SPINE_POSTER_STR (char** buf, struct MOR_SPINE_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_MOR_REF_POSTER_STR (char** buf, struct MOR_REF_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_MOR_ODO_POSTER_STR (char** buf, struct MOR_ODO_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_MOR_MEPOS_POSTER_STR (char** buf, struct MOR_MEPOS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_MOR_GENOM_STR (char** buf, struct MOR_GENOM_STR *x, int nDim, int *dims );
int scan_buf_struct_MOR_ROBOT_DATA (char** buf, struct MOR_ROBOT_DATA *x, int nDim, int *dims );
int scan_buf_struct_MOR_WHEEL_DATA (char** buf, struct MOR_WHEEL_DATA *x, int nDim, int *dims );
int scan_buf_struct_MOR_SPINE_STATE (char** buf, struct MOR_SPINE_STATE *x, int nDim, int *dims );
int scan_buf_struct_MOR_SPINE_REF (char** buf, struct MOR_SPINE_REF *x, int nDim, int *dims );
int scan_buf_struct_MOR_TRACK_PARAMS (char** buf, struct MOR_TRACK_PARAMS *x, int nDim, int *dims );
int scan_buf_enum_MOR_MODE (char** buf, enum MOR_MODE *x, int nDim, int *dims );
int scan_buf_struct_MOR_INIT_PARAMS (char** buf, struct MOR_INIT_PARAMS *x, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

int scan_buf_MOR_INIT_PARAMS (char** buf, MOR_INIT_PARAMS *x, int nDim, int *dims );
int scan_buf_MOR_MODE (char** buf, MOR_MODE *x, int nDim, int *dims );
int scan_buf_MOR_TRACK_PARAMS (char** buf, MOR_TRACK_PARAMS *x, int nDim, int *dims );
int scan_buf_MOR_SPINE_REF (char** buf, MOR_SPINE_REF *x, int nDim, int *dims );
int scan_buf_MOR_SPINE_STATE (char** buf, MOR_SPINE_STATE *x, int nDim, int *dims );
int scan_buf_MOR_WHEEL_DATA (char** buf, MOR_WHEEL_DATA *x, int nDim, int *dims );
int scan_buf_MOR_ROBOT_DATA (char** buf, MOR_ROBOT_DATA *x, int nDim, int *dims );
int scan_buf_MOR_GENOM_STR (char** buf, MOR_GENOM_STR *x, int nDim, int *dims );
int scan_buf_MOR_MEPOS_POSTER_STR (char** buf, MOR_MEPOS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_MOR_ODO_POSTER_STR (char** buf, MOR_ODO_POSTER_STR *x, int nDim, int *dims );
int scan_buf_MOR_REF_POSTER_STR (char** buf, MOR_REF_POSTER_STR *x, int nDim, int *dims );
int scan_buf_MOR_SPINE_POSTER_STR (char** buf, MOR_SPINE_POSTER_STR *x, int nDim, int *dims );
int scan_buf_MOR_RAWDATA_POSTER_STR (char** buf, MOR_RAWDATA_POSTER_STR *x, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* MOR_SCAN_H */

