
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef mor_TCLSERV_CLIENT_MSG_LIB_H
#define mor_TCLSERV_CLIENT_MSG_LIB_H

#include <server/morType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int morTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int morTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int morTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 MOR_INIT_PARAMS *(in_initParams) 
		);

int morTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int morTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				MOR_INIT_PARAMS *(in_initParams) ,
				
				int *bilan);

int morTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					MOR_INIT_PARAMS *(in_initParams) ,
					
					int *bilan);




int morTclservClientGetConfigRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int morTclservClientGetConfigReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       GENPOS_CART_STATE *(out_robot),
			       int *bilan);

int morTclservClientGetConfigRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 GENPOS_CART_STATE *(out_robot),
				 int *bilan);




int morTclservClientSetPosRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CONFIG *(in_setPosStr)
		);

int morTclservClientSetPosReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int morTclservClientSetPosRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CONFIG *(in_setPosStr) ,
				 
				 int *bilan);




int morTclservClientGetRefRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int morTclservClientGetRefReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       GENPOS_CART_REF *(out_ref),
			       int *bilan);

int morTclservClientGetRefRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 GENPOS_CART_REF *(out_ref),
				 int *bilan);




int morTclservClientSetRefRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_REF *(in_ref)
		);

int morTclservClientSetRefReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int morTclservClientSetRefRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_REF *(in_ref) ,
				 
				 int *bilan);




int morTclservClientGetCmdParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int morTclservClientGetCmdParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       GENPOS_CART_CMD_PARAM *(out_cmd),
			       int *bilan);

int morTclservClientGetCmdParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 GENPOS_CART_CMD_PARAM *(out_cmd),
				 int *bilan);




int morTclservClientSetCmdParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CMD_PARAM *(in_cmd)
		);

int morTclservClientSetCmdParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int morTclservClientSetCmdParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CMD_PARAM *(in_cmd) ,
				 
				 int *bilan);




int morTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int morTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int morTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int morTclservClientJoystickOnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int morTclservClientJoystickOnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int morTclservClientJoystickOnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int morTclservClientJoystickOnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int morTclservClientTrackRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 MOR_TRACK_PARAMS *(in_trackParams) 
		);

int morTclservClientTrackReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int morTclservClientTrackRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				MOR_TRACK_PARAMS *(in_trackParams) ,
				
				int *bilan);

int morTclservClientTrackRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					MOR_TRACK_PARAMS *(in_trackParams) ,
					
					int *bilan);




int morTclservClientSetPomRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GENPOS_POSTER_NAME *(in_mePosterName) 
		);

int morTclservClientSetPomReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int morTclservClientSetPomRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GENPOS_POSTER_NAME *(in_mePosterName) ,
				
				int *bilan);

int morTclservClientSetPomRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GENPOS_POSTER_NAME *(in_mePosterName) ,
					
					int *bilan);




int morTclservClientMoveSpineRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 MOR_SPINE_REF *(in_spineRef) 
		);

int morTclservClientMoveSpineReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int morTclservClientMoveSpineRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				MOR_SPINE_REF *(in_spineRef) ,
				
				int *bilan);

int morTclservClientMoveSpineRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					MOR_SPINE_REF *(in_spineRef) ,
					
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* morTCLSERV_CLIENT_MSG_LIB_H */

