
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] morInstall] >= 0 } {
    interp expose {} morInstall
}

proc ::morInstall { name } {
    foreach rqst { "Init" "GetConfig" "SetPos" "GetRef" "SetRef" "GetCmdParam" "SetCmdParam" "Stop" "JoystickOn" "Track" "SetPom" "MoveSpine" "MEPosmePosPosterRead" "OdoRobotPosterRead" "RefRefPosterRead" "SpineStatePosterRead" "SpineRefPosterRead" "RawDataDataPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} mor$rqst $name
    }
}

interp hide {} morInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] morInit] >= 0 } {
    interp expose {} morInit
}
if { [lsearch [interp hidden] morInitFormatOutput] >= 0 } {
    interp expose {} morInitFormatOutput
}

proc ::morInit { name args } {
    set format {}
    lappend format [list string "initParams.canDev.name" "" ]
    lappend format [list string "initParams.relayBoardDev.name" "" ]
    lappend format [list int "initParams.initBase" 0 ]
    lappend format [list int "initParams.initSpine" 0 ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Connect to robot hardware and reset motors" \
	"MOR_INIT_PARAMS\n| GEN_STRING128\n| | char name\[128\]\n| GEN_STRING128\n| | char name\[128\]\n| int initBase\n| int initSpine\n" \
	4 \
	$format \
	$args ]
}


proc ::morInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morInit
interp hide {} morInitFormatOutput





# GetConfig ----------------------------------------------------------

if { [lsearch [interp hidden] morGetConfig] >= 0 } {
    interp expose {} morGetConfig
}
if { [lsearch [interp hidden] morGetConfigFormatOutput] >= 0 } {
    interp expose {} morGetConfigFormatOutput
}

proc ::morGetConfig { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConfig" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::morGetConfigFormatOutput { list } {
    set format { {} status { } { robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morGetConfig
interp hide {} morGetConfigFormatOutput





# SetPos ----------------------------------------------------------

if { [lsearch [interp hidden] morSetPos] >= 0 } {
    interp expose {} morSetPos
}
if { [lsearch [interp hidden] morSetPosFormatOutput] >= 0 } {
    interp expose {} morSetPosFormatOutput
}

proc ::morSetPos { name args } {
    set format {}
    lappend format [list double "setPosStr.x" 0.0 ]
    lappend format [list double "setPosStr.y" 0.0 ]
    lappend format [list double "setPosStr.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPos" \
	"** undocumented **" \
	"GENPOS_CART_CONFIG\n| double x\n| double y\n| double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::morSetPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morSetPos
interp hide {} morSetPosFormatOutput





# GetRef ----------------------------------------------------------

if { [lsearch [interp hidden] morGetRef] >= 0 } {
    interp expose {} morGetRef
}
if { [lsearch [interp hidden] morGetRefFormatOutput] >= 0 } {
    interp expose {} morGetRefFormatOutput
}

proc ::morGetRef { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetRef" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::morGetRefFormatOutput { list } {
    set format { {} status { } { ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morGetRef
interp hide {} morGetRefFormatOutput





# SetRef ----------------------------------------------------------

if { [lsearch [interp hidden] morSetRef] >= 0 } {
    interp expose {} morSetRef
}
if { [lsearch [interp hidden] morSetRefFormatOutput] >= 0 } {
    interp expose {} morSetRefFormatOutput
}

proc ::morSetRef { name args } {
    set format {}
    lappend format [list int "ref.numRef" 0 ]
    lappend format [list int "ref.tickPeriod" 0 ]
    lappend format [list { "GENPOS_POS_AND_SPEED_DATA" "GENPOS_SPEED_DATA" "GENPOS_POS_DATA" } "ref.dataType" "" ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "ref.backFlag" "" ]
    lappend format [list double "ref.x" 0.0 ]
    lappend format [list double "ref.y" 0.0 ]
    lappend format [list double "ref.theta" 0.0 ]
    lappend format [list double "ref.v" 0.0 ]
    lappend format [list double "ref.vt" 0.0 ]
    lappend format [list double "ref.w" 0.0 ]
    lappend format [list double "ref.vmax" 0.0 ]
    lappend format [list double "ref.wmax" 0.0 ]
    lappend format [list double "ref.linAccelMax" 0.0 ]
    lappend format [list double "ref.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetRef" \
	"** undocumented **" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	14 \
	$format \
	$args ]
}


proc ::morSetRefFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morSetRef
interp hide {} morSetRefFormatOutput





# GetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] morGetCmdParam] >= 0 } {
    interp expose {} morGetCmdParam
}
if { [lsearch [interp hidden] morGetCmdParamFormatOutput] >= 0 } {
    interp expose {} morGetCmdParamFormatOutput
}

proc ::morGetCmdParam { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetCmdParam" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::morGetCmdParamFormatOutput { list } {
    set format { {} status { } { cmd { } distPoint { } KpLongit { } KiLongit { } KpTransv { } KiTransv { } KpAng { } KiAng { } longitErrorMax { } transvErrorMax { } longitMaxErrSum { } transvMaxErrSum { } angErrorMax { } angMaxErrSum { } longitMaxGap { } transvMaxGap { } angMaxGap } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morGetCmdParam
interp hide {} morGetCmdParamFormatOutput





# SetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] morSetCmdParam] >= 0 } {
    interp expose {} morSetCmdParam
}
if { [lsearch [interp hidden] morSetCmdParamFormatOutput] >= 0 } {
    interp expose {} morSetCmdParamFormatOutput
}

proc ::morSetCmdParam { name args } {
    set format {}
    lappend format [list double "cmd.distPoint" 0.0 ]
    lappend format [list double "cmd.KpLongit" 0.0 ]
    lappend format [list double "cmd.KiLongit" 0.0 ]
    lappend format [list double "cmd.KpTransv" 0.0 ]
    lappend format [list double "cmd.KiTransv" 0.0 ]
    lappend format [list double "cmd.KpAng" 0.0 ]
    lappend format [list double "cmd.KiAng" 0.0 ]
    lappend format [list double "cmd.longitErrorMax" 0.0 ]
    lappend format [list double "cmd.transvErrorMax" 0.0 ]
    lappend format [list double "cmd.longitMaxErrSum" 0.0 ]
    lappend format [list double "cmd.transvMaxErrSum" 0.0 ]
    lappend format [list double "cmd.angErrorMax" 0.0 ]
    lappend format [list double "cmd.angMaxErrSum" 0.0 ]
    lappend format [list double "cmd.longitMaxGap" 0.0 ]
    lappend format [list double "cmd.transvMaxGap" 0.0 ]
    lappend format [list double "cmd.angMaxGap" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdParam" \
	"** undocumented **" \
	"GENPOS_CART_CMD_PARAM\n| double distPoint\n| double KpLongit\n| double KiLongit\n| double KpTransv\n| double KiTransv\n| double KpAng\n| double KiAng\n| double longitErrorMax\n| double transvErrorMax\n| double longitMaxErrSum\n| double transvMaxErrSum\n| double angErrorMax\n| double angMaxErrSum\n| double longitMaxGap\n| double transvMaxGap\n| double angMaxGap\n" \
	16 \
	$format \
	$args ]
}


proc ::morSetCmdParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morSetCmdParam
interp hide {} morSetCmdParamFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] morStop] >= 0 } {
    interp expose {} morStop
}
if { [lsearch [interp hidden] morStopFormatOutput] >= 0 } {
    interp expose {} morStopFormatOutput
}

proc ::morStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::morStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morStop
interp hide {} morStopFormatOutput





# JoystickOn ----------------------------------------------------------

if { [lsearch [interp hidden] morJoystickOn] >= 0 } {
    interp expose {} morJoystickOn
}
if { [lsearch [interp hidden] morJoystickOnFormatOutput] >= 0 } {
    interp expose {} morJoystickOnFormatOutput
}

proc ::morJoystickOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "JoystickOn" \
	"Activate joystick motion mode" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::morJoystickOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morJoystickOn
interp hide {} morJoystickOnFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] morTrack] >= 0 } {
    interp expose {} morTrack
}
if { [lsearch [interp hidden] morTrackFormatOutput] >= 0 } {
    interp expose {} morTrackFormatOutput
}

proc ::morTrack { name args } {
    set format {}
    lappend format [list string "trackParams.posterName.name" "" ]
    lappend format [list { "GENPOS_TRACK_TRAILER" "GENPOS_TRACK_SPEED" "GENPOS_TRACK_CONFIG" "GENPOS_TRACK_POS" "GENPOS_NO_TRACKING" } "trackParams.mode" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"** undocumented **" \
	"MOR_TRACK_PARAMS\n| GENPOS_POSTER_NAME\n| | char name\[32\]\n| GENPOS_TRACK_MODE mode\n" \
	2 \
	$format \
	$args ]
}


proc ::morTrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morTrack
interp hide {} morTrackFormatOutput





# SetPom ----------------------------------------------------------

if { [lsearch [interp hidden] morSetPom] >= 0 } {
    interp expose {} morSetPom
}
if { [lsearch [interp hidden] morSetPomFormatOutput] >= 0 } {
    interp expose {} morSetPomFormatOutput
}

proc ::morSetPom { name args } {
    set format {}
    lappend format [list string "mePosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SetPom" \
	"** undocumented **" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::morSetPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morSetPom
interp hide {} morSetPomFormatOutput





# MoveSpine ----------------------------------------------------------

if { [lsearch [interp hidden] morMoveSpine] >= 0 } {
    interp expose {} morMoveSpine
}
if { [lsearch [interp hidden] morMoveSpineFormatOutput] >= 0 } {
    interp expose {} morMoveSpineFormatOutput
}

proc ::morMoveSpine { name args } {
    set format {}
    lappend format [list double "spineRef.pos" 0.0 ]
    lappend format [list double "spineRef.speed" 0.0 ]

    return [ ::cs::rqstSend "${name}" "MoveSpine" \
	"Move spine to a given position" \
	"MOR_SPINE_REF\n| double pos\n| double speed\n" \
	2 \
	$format \
	$args ]
}


proc ::morMoveSpineFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morMoveSpine
interp hide {} morMoveSpineFormatOutput





# MEPosmePos ----------------------------------------------------------

if { [lsearch [interp hidden] morMEPosmePosPosterRead] >= 0 } {
    interp expose {} morMEPosmePosPosterRead
}
if { [lsearch [interp hidden] morMEPosmePosPosterFormatOutput] >= 0 } {
    interp expose {} morMEPosmePosPosterFormatOutput
}

proc ::morMEPosmePosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosmePos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::morMEPosmePosPosterFormatOutput { list } {
    set format { {} status { } { mePos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morMEPosmePosPosterRead
interp hide {} morMEPosmePosPosterFormatOutput





# OdoRobot ----------------------------------------------------------

if { [lsearch [interp hidden] morOdoRobotPosterRead] >= 0 } {
    interp expose {} morOdoRobotPosterRead
}
if { [lsearch [interp hidden] morOdoRobotPosterFormatOutput] >= 0 } {
    interp expose {} morOdoRobotPosterFormatOutput
}

proc ::morOdoRobotPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot" \
	"GENPOS_CART_STATE\n| double xRef\n| double yRef\n| double xRob\n| double yRob\n| double theta\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::morOdoRobotPosterFormatOutput { list } {
    set format { {} status { } { Robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morOdoRobotPosterRead
interp hide {} morOdoRobotPosterFormatOutput





# RefRef ----------------------------------------------------------

if { [lsearch [interp hidden] morRefRefPosterRead] >= 0 } {
    interp expose {} morRefRefPosterRead
}
if { [lsearch [interp hidden] morRefRefPosterFormatOutput] >= 0 } {
    interp expose {} morRefRefPosterFormatOutput
}

proc ::morRefRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RefRef" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::morRefRefPosterFormatOutput { list } {
    set format { {} status { } { Ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morRefRefPosterRead
interp hide {} morRefRefPosterFormatOutput





# SpineState ----------------------------------------------------------

if { [lsearch [interp hidden] morSpineStatePosterRead] >= 0 } {
    interp expose {} morSpineStatePosterRead
}
if { [lsearch [interp hidden] morSpineStatePosterFormatOutput] >= 0 } {
    interp expose {} morSpineStatePosterFormatOutput
}

proc ::morSpineStatePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SpineState" \
	"MOR_SPINE_STATE\n| double pos\n| double speed\n| unsigned int stopSwitches\n| int unused\n" \
	$args ]
}


proc ::morSpineStatePosterFormatOutput { list } {
    set format { {} status { } { State { } pos { } speed { } stopSwitches { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morSpineStatePosterRead
interp hide {} morSpineStatePosterFormatOutput





# SpineRef ----------------------------------------------------------

if { [lsearch [interp hidden] morSpineRefPosterRead] >= 0 } {
    interp expose {} morSpineRefPosterRead
}
if { [lsearch [interp hidden] morSpineRefPosterFormatOutput] >= 0 } {
    interp expose {} morSpineRefPosterFormatOutput
}

proc ::morSpineRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SpineRef" \
	"MOR_SPINE_REF\n| double pos\n| double speed\n" \
	$args ]
}


proc ::morSpineRefPosterFormatOutput { list } {
    set format { {} status { } { Ref { } pos { } speed } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morSpineRefPosterRead
interp hide {} morSpineRefPosterFormatOutput





# RawDataData ----------------------------------------------------------

if { [lsearch [interp hidden] morRawDataDataPosterRead] >= 0 } {
    interp expose {} morRawDataDataPosterRead
}
if { [lsearch [interp hidden] morRawDataDataPosterFormatOutput] >= 0 } {
    interp expose {} morRawDataDataPosterFormatOutput
}

proc ::morRawDataDataPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RawDataData" \
	"MOR_ROBOT_DATA\n| unsigned int relayState\n| int charge_c\n| int voltage\n| int temperature\n| MOR_WHEEL_DATA\n| | double steerVel\n| | double steerPos\n| | double driveVel\n| | double drivePos\n| | double steerCurrent\n| | double driveCurrent\n| | int steerMotorState\n| | int driveMotorState\n" \
	$args ]
}


proc ::morRawDataDataPosterFormatOutput { list } {
    set format { {} status { } { Data { } relayState { } charge_c { } voltage { } temperature { 4 } { wheels { } steerVel { } steerPos { } driveVel { } drivePos { } steerCurrent { } driveCurrent { } steerMotorState { } driveMotorState } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} morRawDataDataPosterRead
interp hide {} morRawDataDataPosterFormatOutput


